# Contributing to JS MediaTags

## New contributor
All backgrounds are welcomed.

If you're not that familiar with the code base or JavaScript, and still want to contribute, you're welcomed to ask for help. I'll work with you on the issues or pull requests towards a solution we're both happy with.

You also do not need to be a great english writer / speaker (I'm certainly not) to participate in this project. We'll work together to overcome language obstacles.

## Code changes
When creating a Pull Request make sure to:
* not include post processed files like `dist/*`.
* include unit tests for your changes
  * when adding new ID3 frames check this [file](https://github.com/aadsm/jsmediatags/blob/master/src/__tests__/ID3v2FrameReader-test.js) fo examples. 
* run `npm test`.

## Coding conventions
There's no particular style or pickiness at the moment but follow this:
* 2 spaces for indentation.
* Make it consistent with the rest of the code.

_This list will be updated when new situations show up_.

## Help wanted
If you're just looking to contribute to open source projects with no specific feature or bug fixing in mind [create an issue](https://github.com/aadsm/jsmediatags/issues/new) asking for one. The different ways to help are:
* Bug fixing
* New features
* Code coverage
* Documentation
* Blog posts
